unit hiElem;

interface

uses Kol,Share,Debug;

type
  THIElem = class(TDebug)
   private
   public
    _prop_Pack:string;

    _data_Pack:THI_Event;
    _event_onGroupExists:THI_Event;
    _event_onEnumElements:THI_Event;
    _event_onResult:THI_Event;

    procedure _work_doOpenDB(var _Data:TData; Index:word);
    procedure _work_doCloseDB(var _Data:TData; Index:word);
    procedure _work_doCreateHiAsmDB(var _Data:TData; Index:word);
    procedure _work_doAddGroup(var _Data:TData; Index:word);
    procedure _work_doAddElement(var _Data:TData; Index:word);
    procedure _work_doEnumTabs(var _Data:TData; Index:word);
    procedure _work_doEnumElements(var _Data:TData; Index:word);
    procedure _work_doGroupExists(var _Data:TData; Index:word);
    procedure _work_doElementExists(var _Data:TData; Index:word);
    procedure _work_doDeleteElement(var _Data:TData; Index:word);
    procedure _work_doInstallEl(var _Data:TData; Index:word);
    procedure _work_doRemoveFromName(var _Data:TData; Index:word);
    procedure _work_doUnInstallEl(var _Data:TData; Index:word);
    procedure _work_doInstallPackage(var _Data:TData; Index:word);
    procedure _work_onEnumTabs(var _Data:TData; Index:word);
    procedure _work_onElementExists(var _Data:TData; Index:word);
  end;

implementation
type
  TEnumTabsProc = procedure (Name,Info:PChar; user:pointer); stdcall;

procedure OpenDB(dbname:PChar); stdcall; external 'elmen.dll';
procedure CloseDB; stdcall; external 'elmen.dll';
procedure CreateHiAsmDB; stdcall; external 'elmen.dll';
procedure AddGroup(name, info:PChar); stdcall; external 'elmen.dll';
procedure AddElement(id, name, group:PChar); stdcall; external 'elmen.dll';
procedure EnumTabs(proc:TEnumTabsProc; user:pointer); stdcall; external 'elmen.dll';
procedure EnumElements(tab:PChar; proc:TEnumTabsProc; user:pointer); stdcall; external 'elmen.dll';
function GroupExists(name:PChar):boolean; stdcall; external 'elmen.dll';
function ElementExists(name:PChar):boolean; stdcall; external 'elmen.dll';
procedure DeleteElement(name:PChar); stdcall; external 'elmen.dll';
procedure InstallEl(fn:PChar); stdcall; external 'hitools.dll';
procedure RemoveFromName(Name,fdir:PChar); stdcall; external 'hitools.dll';
procedure UnInstallEl(fn:PChar); stdcall; external 'hitools.dll';
procedure InstallPackage(fn:pchar); stdcall; external 'hitools.dll';

procedure THIElem._work_doOpenDB;
begin

end;

procedure THIElem._work_doCloseDB;
begin

end;

procedure THIElem._work_doCreateHiAsmDB;
begin

end;

procedure THIElem._work_doAddGroup;
begin

end;

procedure THIElem._work_doAddElement;
begin

end;

procedure THIElem._work_doEnumTabs;
begin

end;

procedure THIElem._work_doEnumElements;
begin

end;

procedure THIElem._work_doGroupExists;
begin

end;

procedure THIElem._work_doElementExists;
begin

end;

procedure THIElem._work_doDeleteElement;
begin

end;

procedure THIElem._work_doInstallEl;
begin
  InstallEl(PChar(toString(_Data)));
end;

procedure THIElem._work_doRemoveFromName;
begin
  RemoveFromName(PChar(toString(_Data)),PChar(ReadString(_Data, _Data_Pack, _prop_Pack)));
end;

procedure THIElem._work_doUnInstallEl;
begin
  UnInstallEl(PChar(toString(_Data)));
end;

procedure THIElem._work_doInstallPackage;
begin

end;

procedure THIElem._work_onEnumTabs;
begin

end;

procedure THIElem._work_onElementExists;
begin

end;

end.
